# config valid only for current version of Capistrano
lock '3.7.2'

# DEPLOY
set :application, 'base_site'
# set :deploy_to, '/var/www/amaox' # Default deploy_to directory is /var/www/my_app_name
set :repo_url, 'http://deploy:zpxocivu73@git.sp-service.com.ua/nazarf/bsa_miner.git'
# set :format, :pretty # Default value for :format is :pretty
# set :log_level, :debug # Default value for :log_level is :debug
# set :pty, true # Default value for :pty is false
# set :linked_files, fetch(:linked_files, []).push('config/vacancies.yml') # Default is []
set :linked_dirs, fetch(:linked_dirs, []).push('log', 'public/uploads', 'files') # Default is []
# set :default_env, { path: "/opt/ruby/bin:$PATH" } # Default value for default_env is {}
# set :keep_releases, 5 # Default value for keep_releases is 5

# RVM
# set :rvm_type, :user # Defaults to: :auto
set :rvm_ruby_version, '2.5.1' # Defaults to: 'default'
# set :rvm_custom_path, '~/.rvm' # only needed if not detected

# RAILS
set :rails_env, 'production' # If the environment differs from the stage name
# set :migration_role, 'migrator' # Defaults to 'db'
# set :conditionally_migrate, true # Defaults to false. If true, it's skip migration if files in db/migrate not modified
# set :assets_roles, [:web, :app] # Defaults to [:web]

# BUNDLER
# In order to the bundler install gems to default directory otherwise it will be create gems folder in project directory
set :bundle_path, -> {}
set :bundle_flags, '--system --quiet'

# WHENEVER
# set :whenever_environment, -> { fetch(:stage) }
# set :whenever_identifier, -> { "#{fetch(:application)}_#{fetch(:stage)}" }

puts "Started deploy in #{fetch(:stage)} mode!"

namespace :deploy do
  desc 'Restart application'
  task :restart do
    on roles(:app) do
      execute "mkdir -p #{File.join(current_path, 'tmp')}; touch #{File.join(current_path, 'tmp', 'restart.txt')}"
    end
  end

  desc 'Reload the database with seed data'
  task :seed do
    on roles(:app) do
      within "#{current_path}" do
        with rails_env: :production do
          execute :rake, "db:seed"
        end
      end
    end
  end

  desc 'Tail production log'
  task :tail_log do
    on roles(:app) do
      trap('INT') { puts 'Interupted'; exit 0; }
      execute "tail -f #{shared_path}/log/production.log" do |channel, stream, data|
        puts # for an extra line break before the host name
        puts "#{channel[:host]}: #{data}"
        break if stream == :err
      end
    end
  end

  after 'deploy:publishing', 'deploy:restart'

  after :restart, :x_bin_rails do
    on roles(:web), in: :groups, limit: 3, wait: 10 do
      within release_path do
        execute :chmod, "u+x bin/rails"
      end
    end
  end

  after :restart, :clear_cache do
    on roles(:web), in: :groups, limit: 3, wait: 10 do
      # Here we can do anything such as:
      # within release_path do
      #   execute :rake, 'cache:clear'
      # end
    end
  end
end
